Require Import bool.
Require Import connectives.
Require Import leibniz.
Require Import logic.
Require Import nat.
Parameter bigop : forall (H:Type), nat.nat -> (nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H.
Parameter bigop_body : forall (H:Type), nat.nat -> (nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H.
Axiom axiom_bigop_O : forall H, connectives.equal ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop (H) nat.O) (bigop_body (H) nat.O).
Definition eq_bigop_O : forall H, leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop (H) nat.O) (bigop_body (H) nat.O) := fun (H:Type) => ((((connectives.equal_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop (H) nat.O)) (bigop_body (H) nat.O)) ((axiom_bigop_O) (H)).
Axiom axiom_bigop_S : forall H, forall (n:nat.nat), connectives.equal ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop (H) (nat.S n)) (bigop_body (H) (nat.S n)).
Definition eq_bigop_S : forall H, forall (n:nat.nat), leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop (H) (nat.S n)) (bigop_body (H) (nat.S n)) := fun (H:Type) => fun (n:nat.nat) => ((((connectives.equal_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop (H) (nat.S n))) (bigop_body (H) (nat.S n))) (((axiom_bigop_S) (H)) (n)).
Definition sym_eq_bigop_S : forall H, forall (n:nat.nat), leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop_body (H) (nat.S n)) (bigop (H) (nat.S n)) := fun (H:Type) => fun (n:nat.nat) => ((((leibniz.sym_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop (H) (nat.S n))) (bigop_body (H) (nat.S n))) (((eq_bigop_S) (H)) (n)).
Axiom axiom_bigop_body_O : forall H, connectives.equal ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop_body (H) nat.O) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => nil).
Definition eq_bigop_body_O : forall H, leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop_body (H) nat.O) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => nil) := fun (H:Type) => ((((connectives.equal_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop_body (H) nat.O)) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => nil)) ((axiom_bigop_body_O) (H)).
Axiom axiom_bigop_body_S : forall H, forall (n:nat.nat), connectives.equal ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop_body (H) (nat.S n)) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => bool.match_bool_type (H) (op (f n) (bigop (H) n p nil op f)) (bigop (H) n p nil op f) (p n)).
Definition eq_bigop_body_S : forall H, forall (n:nat.nat), leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop_body (H) (nat.S n)) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => bool.match_bool_type (H) (op (f n) (bigop (H) n p nil op f)) (bigop (H) n p nil op f) (p n)) := fun (H:Type) => fun (n:nat.nat) => ((((connectives.equal_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop_body (H) (nat.S n))) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => bool.match_bool_type (H) (op (f n) (bigop (H) n p nil op f)) (bigop (H) n p nil op f) (p n))) (((axiom_bigop_body_S) (H)) (n)).
Definition sym_eq_bigop_body_S : forall H, forall (n:nat.nat), leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => bool.match_bool_type (H) (op (f n) (bigop (H) n p nil op f)) (bigop (H) n p nil op f) (p n)) (bigop_body (H) (nat.S n)) := fun (H:Type) => fun (n:nat.nat) => ((((leibniz.sym_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop_body (H) (nat.S n))) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => bool.match_bool_type (H) (op (f n) (bigop (H) n p nil op f)) (bigop (H) n p nil op f) (p n))) (((eq_bigop_body_S) (H)) (n)).
Definition bigop_Sfalse : forall B, forall (k:nat.nat), forall (p:(nat.nat -> bool.bool)), forall (nil:B), forall (op:(B -> B -> B)), forall (f:(nat.nat -> B)), (logic.eq (bool.bool) (p k) bool.false) -> logic.eq (B) (bigop (B) (nat.S k) (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i)) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i)) := fun (B:Type) => fun (k:nat.nat) => fun (p:nat.nat -> bool.bool) => fun (nil:B) => fun (op:B -> B -> B) => fun (f:nat.nat -> B) => ((((sym_eq_bigop_S) (B)) (k)) (fun (y:((nat.nat -> bool.bool) -> B -> (B -> B -> B) -> (nat.nat -> B) -> B)) => (logic.eq (bool.bool) (p k) bool.false) -> logic.eq (B) (y (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i)) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i)))) (((((sym_eq_bigop_body_S) (B)) (k)) (fun (y:((nat.nat -> bool.bool) -> B -> (B -> B -> B) -> (nat.nat -> B) -> B)) => (logic.eq (bool.bool) (p k) bool.false) -> logic.eq (B) (y (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i)) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i)))) (fun (H:logic.eq (bool.bool) (p k) bool.false) => (((((((logic.eq_ind_r) (bool.bool)) (bool.false)) (fun (x:bool.bool) => logic.eq (B) (bool.match_bool_type (B) (op (f k) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i))) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i)) x) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i)))) ((((((bool.eq_match_bool_type_false) (B)) (op (f k) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i)))) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i))) (fun (y:B) => logic.eq (B) (bool.match_bool_type (B) (op (f k) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i))) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i)) bool.false) y)) (((logic.refl) (B)) (bool.match_bool_type (B) (op (f k) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i))) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i)) bool.false)))) (p k)) (H)))).
Definition bigop_false : forall B, forall (n:nat.nat), forall (nil:B), forall (op:(B -> B -> B)), forall (f:(nat.nat -> B)), logic.eq (B) (bigop (B) n (fun (i:nat.nat) => bool.false) nil op (fun (i:nat.nat) => f i)) nil := fun (B:Type) => fun (n:nat.nat) => fun (nil:B) => fun (op:B -> B -> B) => fun (f:nat.nat -> B) => ((((nat.nat_ind) (fun (_x_365:nat.nat) => logic.eq (B) (bigop (B) _x_365 (fun (i:nat.nat) => bool.false) nil op (fun (i:nat.nat) => f i)) nil)) ((((eq_bigop_body_O) (B)) (fun (y:((nat.nat -> bool.bool) -> B -> (B -> B -> B) -> (nat.nat -> B) -> B)) => logic.eq (B) (bigop (B) nat.O (fun (i:nat.nat) => bool.false) nil op (fun (i:nat.nat) => f i)) (y (fun (i:nat.nat) => bool.false) nil op (fun (i:nat.nat) => f i)))) ((((eq_bigop_O) (B)) (fun (y:((nat.nat -> bool.bool) -> B -> (B -> B -> B) -> (nat.nat -> B) -> B)) => logic.eq (B) (bigop (B) nat.O (fun (i:nat.nat) => bool.false) nil op (fun (i:nat.nat) => f i)) (y (fun (i:nat.nat) => bool.false) nil op (fun (i:nat.nat) => f i)))) (((logic.refl) (B)) (bigop (B) nat.O (fun (i:nat.nat) => bool.false) nil op (fun (i:nat.nat) => f i)))))) (fun (n1:nat.nat) => fun (Hind:logic.eq (B) (bigop (B) n1 (fun (i:nat.nat) => bool.false) nil op (fun (i:nat.nat) => f i)) nil) => (((((((logic.eq_ind_r) (B)) (bigop (B) n1 (fun (i:nat.nat) => bool.false) nil op (fun (i:nat.nat) => f i))) (fun (x:B) => logic.eq (B) x nil)) (((((((logic.rewrite_r) (B)) (nil)) (fun (__:B) => logic.eq (B) __ nil)) (((logic.refl) (B)) (nil))) (bigop (B) n1 (fun (i:nat.nat) => bool.false) nil op (fun (i:nat.nat) => f i))) (Hind))) (bigop (B) (nat.S n1) (fun (i:nat.nat) => bool.false) nil op (fun (i:nat.nat) => f i))) ((((((((bigop_Sfalse) (B)) (n1)) (fun (__:nat.nat) => bool.false)) (nil)) (op)) (f)) (((logic.refl) (bool.bool)) (bool.false)))))) (n).
